package scripts;

import com.stencyl.graphics.G;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.utils.Utils;

import nme.ui.Mouse;
import nme.display.Graphics;
import nme.display.BlendMode;
import nme.events.Event;
import nme.events.TouchEvent;
import nme.net.URLLoader;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Back;
import com.eclecticdesignstudio.motion.easing.Cubic;
import com.eclecticdesignstudio.motion.easing.Elastic;
import com.eclecticdesignstudio.motion.easing.Expo;
import com.eclecticdesignstudio.motion.easing.Linear;
import com.eclecticdesignstudio.motion.easing.Quad;
import com.eclecticdesignstudio.motion.easing.Quart;
import com.eclecticdesignstudio.motion.easing.Quint;
import com.eclecticdesignstudio.motion.easing.Sine;



class Design_12_12_PerusScene extends SceneScript
{          	
	public var _Hit:Bool;
	public var _Drummer:Float;
	public var _Start:Bool;
	public function Hurt():Void
	{
	    if ((_Hit == false))
	    {
	        _Hit = true;
	        propertyChanged("_Hit", _Hit);
	        playSoundOnChannel(getSound(55), Std.int(3));
	        playSoundOnChannel(getSound(58), Std.int(5));
	        for (actorOfType in getActorsOfType(getActorType(0)))
	        {
	            if (actorOfType != null && !actorOfType.dead && !actorOfType.recycled)
	            {
	                actorOfType.shout("Hurted");
	            }
	        }
	        runLater(1000 * 1, function(timeTask:TimedTask):Void
	        {
	            _Hit = false;
	            propertyChanged("_Hit", _Hit);
	        }, null);
	    }
	    else if ((_Hit == true))
	    {
	        for (actorOfType in getActorsOfType(getActorType(5)))
	        {
	            if (actorOfType != null && !actorOfType.dead && !actorOfType.recycled)
	            {
	                actorOfType.shout("Killed");
	            }
	        }
	    }
	}

 
 	public function new(dummy:Int, engine:Engine)
	{
		super(engine);
		nameMap.set("Hit", "_Hit");
		_Hit = false;
		nameMap.set("Drummer", "_Drummer");
		_Drummer = 0.0;
		nameMap.set("Start", "_Start");
		_Start = false;

	}
	
	override public function init()
	{
		stopAllSounds();
		setGameAttribute("Killed?", false);
		setGameAttribute("Vihushoot", false);
		setGameAttribute("Dodger", false);
		setGameAttribute("Started", false);
		setOffscreenTolerance(32, 32, 32, 32);
		runPeriodically(1000 * 20, function(timeTask:TimedTask):Void
		{
		    if ((_Drummer <= 2))
		    {
		        _Drummer = asNumber((_Drummer + 1));
		        propertyChanged("_Drummer", _Drummer);
		    }
		}, null);
		if ((getGameAttribute("Muted") == false))
		{
		    setVolumeForChannel(100/100, Std.int(1));
		    setVolumeForChannel(100/100, Std.int(2));
		    setVolumeForChannel(100/100, Std.int(3));
		    setVolumeForChannel(100/100, Std.int(4));
		    setVolumeForChannel(100/100, Std.int(5));
		    setVolumeForChannel(100/100, Std.int(6));
		    setVolumeForChannel(100/100, Std.int(7));
		    setVolumeForChannel(100/100, Std.int(8));
		    setVolumeForChannel(100/100, Std.int(9));
		}
		else if ((getGameAttribute("Muted") == true))
		{
		    setVolumeForChannel(0/100, Std.int(1));
		    setVolumeForChannel(0/100, Std.int(2));
		    setVolumeForChannel(0/100, Std.int(3));
		    setVolumeForChannel(0/100, Std.int(4));
		    setVolumeForChannel(0/100, Std.int(5));
		    setVolumeForChannel(0/100, Std.int(6));
		    setVolumeForChannel(0/100, Std.int(7));
		    setVolumeForChannel(0/100, Std.int(8));
		    setVolumeForChannel(0/100, Std.int(9));
		}
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled)
		    {
		        if ((isKeyPressed("replay") && !(isTransitioning())))
		        {
		            reloadCurrentScene(null,createCrossfadeTransition((0.5)));
		        }
		        if ((getGameAttribute("Killed?") == true))
		        {
		            setVolumeForChannel(0/100, Std.int(8));
		        }
		    }
		});
		addSoundListener(8, function(list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled)
		    {
		        if ((_Drummer == 0))
		        {
		            playSoundOnChannel(getSound(63), Std.int(8));
		        }
		        else if ((_Drummer == 1))
		        {
		            playSoundOnChannel(getSound(62), Std.int(8));
		        }
		        else if ((_Drummer == 2))
		        {
		            playSoundOnChannel(getSound(61), Std.int(8));
		        }
		        else if ((_Drummer == 3))
		        {
		            playSoundOnChannel(getSound(60), Std.int(8));
		        }
		    }
		});
		addKeyStateListener("Mute", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && pressed)
		    {
		        if ((getGameAttribute("Muted") == false))
		        {
		            setGameAttribute("Muted", true);
		            setVolumeForChannel(0/100, Std.int(1));
		            setVolumeForChannel(0/100, Std.int(2));
		            setVolumeForChannel(0/100, Std.int(3));
		            setVolumeForChannel(0/100, Std.int(4));
		            setVolumeForChannel(0/100, Std.int(5));
		            setVolumeForChannel(0/100, Std.int(6));
		            setVolumeForChannel(0/100, Std.int(7));
		            setVolumeForChannel(0/100, Std.int(8));
		            setVolumeForChannel(0/100, Std.int(9));
		        }
		        else if ((getGameAttribute("Muted") == true))
		        {
		            setGameAttribute("Muted", false);
		            setVolumeForChannel(100/100, Std.int(1));
		            setVolumeForChannel(100/100, Std.int(2));
		            setVolumeForChannel(100/100, Std.int(3));
		            setVolumeForChannel(100/100, Std.int(4));
		            setVolumeForChannel(100/100, Std.int(5));
		            setVolumeForChannel(100/100, Std.int(6));
		            setVolumeForChannel(100/100, Std.int(7));
		            setVolumeForChannel(100/100, Std.int(8));
		            setVolumeForChannel(100/100, Std.int(9));
		        }
		    }
		});
		addKeyStateListener("Throttle", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && pressed)
		    {
		        if ((_Start == false))
		        {
		            _Start = true;
		            propertyChanged("_Start", _Start);
		            playSoundOnChannel(getSound(63), Std.int(8));
		        }
		    }
		});
		addKeyStateListener("Throttle2", function(pressed:Bool, released:Bool, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && pressed)
		    {
		        if ((_Start == false))
		        {
		            _Start = true;
		            propertyChanged("_Start", _Start);
		            playSoundOnChannel(getSound(63), Std.int(8));
		        }
		    }
		});

	}	      	
	
	override public function forwardMessage(msg:String)
	{
		
	}
}