package scripts;

import com.stencyl.graphics.G;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.utils.Utils;

import nme.ui.Mouse;
import nme.display.Graphics;
import nme.display.BlendMode;
import nme.events.Event;
import nme.events.TouchEvent;
import nme.net.URLLoader;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Back;
import com.eclecticdesignstudio.motion.easing.Cubic;
import com.eclecticdesignstudio.motion.easing.Elastic;
import com.eclecticdesignstudio.motion.easing.Expo;
import com.eclecticdesignstudio.motion.easing.Linear;
import com.eclecticdesignstudio.motion.easing.Quad;
import com.eclecticdesignstudio.motion.easing.Quart;
import com.eclecticdesignstudio.motion.easing.Quint;
import com.eclecticdesignstudio.motion.easing.Sine;



class Design_5_5_SmoothCamera extends ActorScript
{          	
	public var _auxX:Float;
	public var _auxY:Float;
	public var _Delay:Float;

 
 	public function new(dummy:Int, actor:Actor, engine:Engine)
	{
		super(actor, engine);	
		nameMap.set("auxX", "_auxX");
		_auxX = 0.0;
		nameMap.set("auxY", "_auxY");
		_auxY = 0.0;
		nameMap.set("Delay", "_Delay");
		_Delay = 15.0;
		nameMap.set("Actor", "actor");

	}
	
	override public function init()
	{
		_auxX = asNumber(actor.getXCenter());
		propertyChanged("_auxX", _auxX);
		_auxY = asNumber(actor.getYCenter());
		propertyChanged("_auxY", _auxY);
		_Delay = asNumber((_Delay + 1));
		propertyChanged("_Delay", _Delay);
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled)
		    {
		        if ((getGameAttribute("Killed?") == false))
		        {
		            if ((getGameAttribute("Started") == false))
		            {
		                _auxX = asNumber((_auxX + ((actor.getXCenter() - _auxX) / _Delay)));
		                propertyChanged("_auxX", _auxX);
		                _auxY = asNumber((_auxY + ((actor.getYCenter() - _auxY) / _Delay)));
		                propertyChanged("_auxY", _auxY);
		                getCamera().setLocation(_auxX, _auxY);
		            }
		            else if ((getGameAttribute("Started") == true))
		            {
		                if ((getGameAttribute("Dodger") == false))
		                {
		                    _auxX = asNumber((_auxX + (((actor.getXCenter() + 180) - _auxX) / _Delay)));
		                    propertyChanged("_auxX", _auxX);
		                    _auxY = asNumber((_auxY + ((actor.getYCenter() - _auxY) / _Delay)));
		                    propertyChanged("_auxY", _auxY);
		                    getCamera().setLocation(_auxX, _auxY);
		                }
		            }
		        }
		    }
		});

	}	      	
	
	override public function forwardMessage(msg:String)
	{
		
	}
}