package scripts;

import com.stencyl.graphics.G;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.utils.Utils;

import nme.ui.Mouse;
import nme.display.Graphics;
import nme.display.BlendMode;
import nme.events.Event;
import nme.events.TouchEvent;
import nme.net.URLLoader;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Back;
import com.eclecticdesignstudio.motion.easing.Cubic;
import com.eclecticdesignstudio.motion.easing.Elastic;
import com.eclecticdesignstudio.motion.easing.Expo;
import com.eclecticdesignstudio.motion.easing.Linear;
import com.eclecticdesignstudio.motion.easing.Quad;
import com.eclecticdesignstudio.motion.easing.Quart;
import com.eclecticdesignstudio.motion.easing.Quint;
import com.eclecticdesignstudio.motion.easing.Sine;



class Design_9_9_VihuBehaviour extends ActorScript
{          	
	public var _Y:Float;
	public var _Destroyed:Bool;
	public var _Dropper:Bool;
	public var _Deplo:Bool;
	public function Kill():Void
	{
	    if ((_Destroyed == false))
	    {
	        playSoundOnChannel(getSound(55), Std.int(2));
	        createRecycledActor(getActorType(15), (actor.getX() - 10), (actor.getY() - 10), Script.FRONT);
	        _Destroyed = true;
	        propertyChanged("_Destroyed", _Destroyed);
	        actor.setIgnoreGravity(!true);
	    }
	}

 
 	public function new(dummy:Int, actor:Actor, engine:Engine)
	{
		super(actor, engine);	
		nameMap.set("Y", "_Y");
		_Y = 0.0;
		nameMap.set("Destroyed?", "_Destroyed");
		_Destroyed = false;
		nameMap.set("Dropper", "_Dropper");
		_Dropper = false;
		nameMap.set("Deplo", "_Deplo");
		_Deplo = false;
		nameMap.set("Actor", "actor");

	}
	
	override public function init()
	{
		actor.setIgnoreGravity(!false);
		actor.makeAlwaysSimulate();
		_Y = asNumber(randomInt(Math.floor(-2), Math.floor(2)));
		propertyChanged("_Y", _Y);
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
		    if ((((_Dropper == true) && (_Destroyed == false)) && actor.isAlive()))
		    {
		        if (actor.isOnScreen())
		        {
		            createRecycledActor(getActorType(24), actor.getX(), actor.getY(), Script.FRONT);
		            if ((getGameAttribute("Vihushoot") == false))
		            {
		                setGameAttribute("Vihushoot", true);
		                playSoundOnChannel(getSound(66), Std.int(9));
		            }
		        }
		    }
		    else if ((((_Dropper == false) && (_Destroyed == false)) && actor.isAlive()))
		    {
		        if (actor.isOnScreen())
		        {
		            createRecycledActor(getActorType(26), actor.getX(), actor.getY(), Script.FRONT);
		            if ((getGameAttribute("Vihushoot") == false))
		            {
		                setGameAttribute("Vihushoot", true);
		                playSoundOnChannel(getSound(66), Std.int(9));
		            }
		        }
		    }
		}, actor);
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled)
		    {
		        if ((_Destroyed == false))
		        {
		            actor.setXVelocity(-2);
		            if ((_Dropper == false))
		            {
		                if ((getGameAttribute("Killed?") == false))
		                {
		                    if ((actor.getY() > getGameAttribute("Y ship")))
		                    {
		                        actor.setYVelocity(-3);
		                    }
		                    else if ((actor.getY() < getGameAttribute("Y ship")))
		                    {
		                        actor.setYVelocity(3);
		                    }
		                }
		                else
		                {
		                    actor.setYVelocity(0);
		                }
		            }
		        }
		        else
		        {
		            actor.setAnimation("" + "Dstr");
		            actor.setXVelocity(0);
		        }
		        if (((actor.getX() < getGameAttribute("X ship")) && (_Destroyed == false)))
		        {
		            recycleActor(actor);
		        }
		    }
		});
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && sameAsAny(getActorGroup(1),event.otherActor.getType(),event.otherActor.getGroup()))
		    {
		        if ((_Destroyed == true))
		        {
		            if ((_Deplo == false))
		            {
		                _Deplo = true;
		                propertyChanged("_Deplo", _Deplo);
		                if ((_Dropper == false))
		                {
		                    createRecycledActor(getActorType(30), actor.getX(), actor.getY(), Script.FRONT);
		                }
		                else
		                {
		                    createRecycledActor(getActorType(32), actor.getX(), actor.getY(), Script.FRONT);
		                }
		                recycleActor(actor);
		            }
		        }
		    }
		});
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && sameAsAny(getActorType(5), event.otherActor.getType(),event.otherActor.getGroup()))
		    {
		        if ((_Destroyed == false))
		        {
		            playSoundOnChannel(getSound(55), Std.int(2));
		            shoutToScene("Hurt");
		            createRecycledActor(getActorType(15), (actor.getX() - 10), (actor.getY() - 10), Script.FRONT);
		            _Destroyed = true;
		            propertyChanged("_Destroyed", _Destroyed);
		            actor.setIgnoreGravity(!true);
		        }
		    }
		});
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled && sameAsAny(getActorGroup(6),event.otherActor.getType(),event.otherActor.getGroup()))
		    {
		        if ((_Destroyed == false))
		        {
		            createRecycledActor(getActorType(15), (actor.getX() - 10), (actor.getY() - 10), Script.FRONT);
		            _Destroyed = true;
		            propertyChanged("_Destroyed", _Destroyed);
		            actor.setIgnoreGravity(!true);
		        }
		    }
		});
		addSoundListener(9, function(list:Array<Dynamic>):Void
		{
		    if (wrapper.enabled)
		    {
		        if ((getGameAttribute("Vihushoot") == true))
		        {
		            setGameAttribute("Vihushoot", false);
		        }
		    }
		});

	}	      	
	
	override public function forwardMessage(msg:String)
	{
		
	}
}